<template>
  <div class="image-list">
    <div class="btn-group mb-2" role="group">
      <router-link v-if="!managing" class="btn btn-primary me-2" :to="albumsRoute">
        <i class="bi bi-chevron-left"></i>
        Albums
      </router-link>
      <button
        v-if="showManageImages && showManageImagesButton"
        type="button"
        class="btn btn-primary me-2"
        @click="onClickManage"
      >
        <i class="bi bi-list-task"></i>
        Manage images
      </button>
      <button v-if="showManageImages && managing" type="button" class="btn btn-primary" @click="onClickFinish">
        <i class="bi bi-check-lg"></i>
        Finish managing
      </button>
    </div>
    <LoadingSpinner v-if="loading" />
    <div class="image-list-images clearfix">
      <div class="image-upload-wrapper" v-if="showImageUpload">
        <ImageUpload
          :url="uploadUrl"
          :allow-multiple="true"
          @image-uploaded="onImageUploaded"
          @queue-complete="onQueueComplete"
        />
      </div>
      <div class="clearfix">
        <ImageListItem
          v-for="image in images"
          :key="image.id"
          :image="image"
          :group-name="groupName"
          :managing="managing || selecting"
          @image-long-press="onImageLongPress"
          @image-selected="onImageSelected"
          @image-unselected="onImageUnselected"
        />
      </div>
      <div v-if="loaded && !showImageUpload && images.length === 0">No images found.</div>
      <ImageListZoomed
        :images="images"
        :group-name="groupName"
        :managing="managing"
        :isCurrentUser="isCurrentUser"
        @button="onButton"
      />
    </div>
    <FixedFooter v-if="managing" @close="onFixedFooterClose">
      <ImageListManaging :albums="albums" :alias="alias" @button="onButton" />
    </FixedFooter>
    <SelectingFixedFooter v-if="selecting" />
  </div>
</template>

<script>
import { ref, computed, watch } from 'vue'
import { useRouter } from 'vue-router'
import { useStore } from 'vuex'
import { FixedFooter, LoadingSpinner, useApi, useConfirmPrompt, useNotification } from '../../core'
import { useAuth } from '../../identity'
import BatchApi from '../api/batch-api.js'
import ImagesApi from '../api/images-api.js'
import ImageUpload from './image-upload.vue'
import ImageListManaging from './image-list-managing.vue'
import ImageListItem from './image-list-item.vue'
import ImageListZoomed from './image-list-zoomed.vue'
import SelectingFixedFooter from './selecting-fixed-footer.vue'

export default {
  name: 'ImageList',
  emits: ['stale'],
  components: {
    FixedFooter,
    LoadingSpinner,
    ImageUpload,
    ImageListManaging,
    ImageListItem,
    ImageListZoomed,
    SelectingFixedFooter,
  },
  props: {
    username: { type: String, required: true },
    albums: { type: Array, required: true },
    alias: { type: String, default: '' },
    selecting: { type: Boolean, default: false },
  },
  setup(props, context) {
    const router = useRouter()
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const confirmPrompt = useConfirmPrompt()
    const notify = useNotification()
    const batchApi = new BatchApi(api, auth)
    const imagesApi = new ImagesApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const managing = ref(false)
    const images = ref([])

    const album = computed(() => {
      return props.albums.find((x) => x.user.username === props.username && x.alias === props.alias)
    })

    const albumId = computed(() => {
      return album.value ? album.value.id : 0
    })

    const albumsRoute = computed(() => {
      return props.username ? { name: 'gallery-albums', params: { username: props.username } } : null
    })

    const uploadUrl = computed(() => {
      return imagesApi.uploadUrl(albumId.value)
    })

    const authenticatedUserId = computed(() => {
      return store.state.identity.session.userId
    })

    const authenticatedUsername = computed(() => {
      return store.state.identity.session.username
    })

    const isCurrentUser = computed(() => {
      return authenticatedUserId.value > 0 && props.username === authenticatedUsername.value
    })

    const showImageUpload = computed(() => {
      return isCurrentUser.value && albumId.value !== 0 && !props.selecting
    })

    const showManageImages = computed(() => {
      return isCurrentUser.value && images.value.length > 0
    })

    const showManageImagesButton = computed(() => {
      return !managing.value && !props.selecting
    })

    const groupName = computed(() => {
      return `album_${props.username}_${props.alias}`
    })

    const onClickManage = () => {
      store.dispatch('gallery/setSelectedImages', [])
      managing.value = true
    }

    const onClickFinish = () => {
      managing.value = false
    }

    const onImageUploaded = (image) => {
      images.value.unshift(image)
      // this.$emit('stale')
    }

    const onQueueComplete = () => {
      context.emit('stale')
    }

    const onImageLongPress = () => {
      if (isCurrentUser.value && !this.selecting) {
        store.dispatch('gallery/setSelectedImages', [])
        managing.value = true
      }
    }

    const onImageSelected = (image) => {
      let selectedImages = store.state.gallery.selectedImages
      const index = selectedImages.findIndex((x) => x.id === image.id)
      if (index === -1) {
        if (props.multiSelect || !store.state.gallery.formName) {
          selectedImages.push(image)
        } else {
          selectedImages = [image]
        }

        store.dispatch('gallery/setSelectedImages', selectedImages)
      }
    }

    const onImageUnselected = (image) => {
      const selectedImages = store.state.gallery.selectedImages
      const index = selectedImages.findIndex((x) => x.id === image.id)
      if (index !== -1) {
        selectedImages.splice(index, 1)
        store.dispatch('gallery/setSelectedImages', selectedImages)
      }
    }

    const onButton = async (code, args) => {
      switch (code) {
        case 'edit-image':
          editImage(args.imageId)
          break

        case 'edit-album':
          editAlbum(args.imageId)
          break

        case 'select-all':
          selectAll()
          break

        case 'select-none':
          selectNone()
          break

        case 'select-inverse':
          selectInverse()
          break

        case 'set-album-cover':
          await setAlbumCoverAsync(args.imageId)
          break

        case 'set-avatar':
          await setAvatarAsync(args.imageId)
          break

        case 'move-selected':
          await moveSelectedAsync(args.imageIds, args.albumId)
          break

        case 'delete-selected':
          deleteSelected(args.imageIds)
          break

        default:
          throw `Unknown button code: '${code}'.`
      }
    }

    const onFixedFooterClose = () => {
      managing.value = false
    }

    const onDeleteSelectedConfirmedAsync = async (imageIds) => {
      const n = imageIds.length
      const s = n !== 1 ? 's' : ''

      try {
        await batchApi.deleteImagesAsync({ imageIds })
        notify.success(`${n} image${s} deleted.`)
        context.emit('stale')
      } catch (ex) {
        notify.error(`Something went wrong trying to delete ${n} image${s}.`, ex)
      }
    }

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      managing.value = false
      images.value = []

      try {
        const response = await imagesApi.fetchAsync({
          username: props.username,
          album: props.alias,
          expand: 'all',
          offset: 0,
          limit: 0, // Don't paginate
        })

        images.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the images.', ex)
      } finally {
        loading.value = false
      }
    }

    const editImage = (imageId) => {
      router.push({
        name: 'gallery-image-edit',
        params: { username: props.username, imageId },
        query: { selecting: props.selecting ? 'true' : undefined },
      })
    }

    const editAlbum = (imageId) => {
      const index = images.value.findIndex((x) => x.id === imageId)
      if (index === -1) {
        return
      }
      const image = images.value[index]
      managing.value = true
      store.dispatch('gallery/setSelectedImages', [image])
      var element = document.querySelector(`#image_${image.id}`)
      if (element) {
        element.scrollIntoView()
      }
    }

    const selectAll = () => {
      const selectedImages = store.state.gallery.selectedImages
        .filter((x) => x.albumId !== albumId.value)
        .concat(images.value)
      store.dispatch('gallery/setSelectedImages', selectedImages)
    }

    const selectNone = () => {
      const selectedImages = store.state.gallery.selectedImages.filter((x) => x.albumId !== albumId.value)
      store.dispatch('gallery/setSelectedImages', selectedImages)
    }

    const selectInverse = () => {
      const selectedImagesFromThisAlbum = store.state.gallery.selectedImages.filter((x) => x.albumId === albumId.value)

      const selectedImages = store.state.gallery.selectedImages
        .filter((x) => x.albumId !== albumId.value)
        .concat(images.value)
        .filter((x) => !selectedImagesFromThisAlbum.includes(x))

      store.dispatch('gallery/setSelectedImages', selectedImages)
    }

    const setAlbumCoverAsync = async (imageId) => {
      const image = images.value.find((x) => x.id === imageId)
      if (!image) {
        return
      }

      try {
        await imagesApi.setAsCoverAsync(image.id)
        notify.success('The album cover has been set.')
        context.emit('stale')
      } catch (ex) {
        notify.error('There was a problem setting the album cover.', ex)
      }
    }

    const setAvatarAsync = async (imageId) => {
      const image = images.value.find((x) => x.id === imageId)
      if (!image) {
        return
      }

      try {
        await imagesApi.setAsAvatarAsync(image.id)
        notify.success('Your avatar has been set.')
        context.emit('stale')
      } catch (ex) {
        notify.error('There was a problem setting your avatar.', ex)
      }
    }

    const moveSelectedAsync = async (imageIds, albumId) => {
      const n = imageIds.length
      const s = n !== 1 ? 's' : ''

      try {
        await batchApi.moveImagesAsync({ imageIds: imageIds, albumId: albumId })
        notify.success(`${n} image${s} moved.`)
        context.emit('stale')
      } catch (ex) {
        notify.error(`Something went wrong trying to move ${n} image${s}.`, ex)
      }
    }

    const deleteSelected = (imageIds) => {
      const n = imageIds.length
      const s = n !== 1 ? 's' : ''

      confirmPrompt
        .show({
          text: `Really delete ${n} image${s}?`,
        })
        .then(
          async () => {
            await onDeleteSelectedConfirmedAsync(imageIds)
          },
          () => {}
        )
    }

    watch(
      () => props.username,
      async () => {
        await loadAsync()
      }
    )

    watch(
      () => props.albums,
      async () => {
        await loadAsync()
      }
    )

    watch(
      () => props.alias,
      async (val) => {
        if (val === '') {
          images.value = []
        } else {
          await loadAsync()
        }
      }
    )

    return {
      loading,
      loaded,
      managing,
      images,
      album,
      albumId,
      albumsRoute,
      uploadUrl,
      authenticatedUserId,
      authenticatedUsername,
      isCurrentUser,
      showImageUpload,
      showManageImages,
      showManageImagesButton,
      groupName,
      onClickManage,
      onClickFinish,
      onImageUploaded,
      onQueueComplete,
      onImageLongPress,
      onImageSelected,
      onImageUnselected,
      onButton,
      onFixedFooterClose,
      onDeleteSelectedConfirmedAsync,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.image-list {
  margin-bottom: 6em;
}

.image-list-images {
  margin-right: -(vars.$gallerySpacing);
  margin-bottom: -(vars.$gallerySpacing);
}

// Larger displays
@media only screen and (min-width: vars.$sm) {
  .image-list-images {
    margin-right: -(vars.$gallerySpacingLarge);
    margin-bottom: -(vars.$gallerySpacingLarge);
  }
}
</style>
